%bcond_without gtk

%bcond_without meson

%global aud_plugin_api %(grep '[ ]*#define[ ]*_AUD_PLUGIN_VERSION[ ]\\+' %{_includedir}/libaudcore/plugin.h 2>/dev/null | sed 's!.*_AUD_PLUGIN_VERSION[ ]*\\([0-9]\\+\\).*!\\1!')
%if 0%{aud_plugin_api} > 0
%global aud_plugin_dep Requires: audacious(plugin-api) = %{aud_plugin_api}
%endif
%{?aud_plugin_dep}

Name: audacious-plugins
Version: 4.4
Release:    1%{?dist}

%global tar_ver %{version}

%global aud_ver 4.4-1
Requires: audacious >= %{aud_ver}

Summary: Plugins for the Audacious audio player
URL: https://audacious-media-player.org/

License: GPLv2+ and LGPLv2+ and GPLv3 and MIT and BSD

Source0: https://distfiles.audacious-media-player.org/%{name}-%{tar_ver}.tar.bz2
Source3: README.licenses
Source100: audacious-plugins-amidi.metainfo.xml
Source101: audacious-plugins-exotic.metainfo.xml
Source102: audacious-plugins-jack.metainfo.xml
Source103: audacious-plugins-ffaudio.metainfo.xml

Patch0: audacious-plugins-3.7-alpha1-xmms-skindir.patch
Patch2: audacious-plugins-3.6-ladspa.patch

BuildRequires: gcc-c++
BuildRequires: make
BuildRequires: meson
BuildRequires: audacious-devel >= %{aud_ver}
BuildRequires: gettext-devel
BuildRequires: pkgconfig(neon)
BuildRequires: pkgconfig(jack)
BuildRequires: pkgconfig(samplerate)
BuildRequires: pkgconfig(soxr)
BuildRequires: pkgconfig(alsa)
BuildRequires: pkgconfig(libpulse)
BuildRequires: pkgconfig(sndfile)
BuildRequires: pkgconfig(wavpack)
BuildRequires: pkgconfig(libsidplayfp) >= 2.0
BuildRequires: pkgconfig(libmodplug)
BuildRequires: pkgconfig(ogg) pkgconfig(vorbis) pkgconfig(vorbisenc) pkgconfig(vorbisfile)
BuildRequires: pkgconfig(flac)
BuildRequires: pkgconfig(fluidsynth)
BuildRequires: pkgconfig(libcdio) pkgconfig(libcdio_cdda) pkgconfig(libcddb)
BuildRequires: pkgconfig(libcue)
BuildRequires: pkgconfig(sdl2)
BuildRequires: pkgconfig(lirc)
BuildRequires: pkgconfig(libxml-2.0)
BuildRequires: pkgconfig(libnotify) pkgconfig(gdk-pixbuf-2.0)
BuildRequires: pkgconfig(libbs2b)
BuildRequires: pkgconfig(libcurl)
BuildRequires: pkgconfig(dbus-1) pkgconfig(dbus-glib-1)
BuildRequires: pkgconfig(adplug)
BuildRequires: pkgconfig(libbinio)
BuildRequires: pkgconfig(libopenmpt)
BuildRequires: pkgconfig(libmms)
BuildRequires: pkgconfig(libmpg123)
BuildRequires: lame-devel
BuildRequires: pkgconfig(opus) pkgconfig(opusfile)
BuildRequires: pkgconfig(json-glib-1.0) >= 1.0
BuildRequires: pkgconfig(libpipewire-0.3) pkgconfig(libspa-0.2)
BuildRequires: pkgconfig(libavcodec) >= 56.60.100
BuildRequires: pkgconfig(libavformat) >= 56.40.101
BuildRequires: pkgconfig(libavutil) >= 54.31.100

BuildRequires: pkgconfig(gdk-x11-3.0)

BuildRequires: pkgconfig(Qt6Core)
BuildRequires: pkgconfig(Qt6Gui)
BuildRequires: pkgconfig(Qt6Widgets)
BuildRequires: pkgconfig(Qt6Multimedia)
BuildRequires: pkgconfig(Qt6Network)
BuildRequires: pkgconfig(x11) pkgconfig(xcb-proto)
BuildRequires: pkgconfig(ampache_browser_1)


Provides:  audacious-plugins-freeworld-mms = %{version}-%{release}

%global __provides_exclude_from ^%{_libdir}/audacious/.*\\.so$


%description
This package provides essential plugins for the Audacious audio player.


%package jack
Summary: Audacious output plugin for Jack Audio Connection Kit
License: BSD
%{?aud_plugin_dep}
Requires: audacious-plugins >= %{aud_ver}

%description jack
This package provides an Audacious output plugin that uses the
Jack Audio Connection Kit (JACK) sound service.


%package exotic
Summary: Optional niche market plugins for Audacious 
License: GPLv2+ and LGPLv2+ and GPLv3 and MIT and BSD
%{?aud_plugin_dep}
Requires: audacious-plugins >= %{aud_ver}
Provides: bundled(game-music-emu) = 0.5.5

%description exotic
This package provides optional plugins for Audacious, which do not aim
at a wide demographic audience. Most users of Audacious do not need this.

For example, included are input plugins for exotic audio file formats,
SID music (from Commodore 64 and compatibles), AdLib/OPL2 emulation,
console game music, the Portable Sound Format PSF1/PSF2, Vortex AM/YM
emulation, Nintendo DS Sound Format 2SF.


%package amidi
Summary: Audacious input plugin for MIDI
License: GPLv2+

%{?aud_plugin_dep}
Requires: audacious-plugins >= %{aud_ver}

%description amidi
This package provides AMIDI-Plug, a modular MIDI music player, as an
input plugin for Audacious.


%package ffaudio
Summary: FFmpeg input plugin for Audacious
License: BSD

%{?aud_plugin_dep}
Requires: audacious-plugins >= %{aud_ver}
Provides: audacious-plugins-freeworld-ffaudio = %{version}-%{release}

%description ffaudio
This package provides FFmpeg as an input plugin for Audacious.


%prep
%autosetup -n %{name}-%{tar_ver} -p1

for i in src/ladspa/plugin.cc
do
    sed -i -e 's!__RPM_LIBDIR__!%{_libdir}!g' $i
    sed -i -e 's!__RPM_LIB__!%{_lib}!g' $i
done
grep -q -s __RPM_LIB * -R && exit 1 || echo

%if %{without meson}
sed -i '\,^.SILENT:,d' buildsys.mk.in
sed -i 's!MAKE} -s!MAKE} !' buildsys.mk.in
%endif


%build
%{!?aud_plugin_dep:echo 'No audacious(plugin-api) dependency!' && exit -1}



%if %{with meson}
%meson \
    -Dsndio=false \
    -Daac=false \
    -Dfilewriter-mp3=true \
    -Dstreamtuner=true \
    -Dffaudio=true \
    -Dgtk=%{?with_gtk:true}%{!?with_gtk:false} \
    -Dqt=true
%meson_build
%else
%configure  \
    --enable-filewriter-mp3 \
    --enable-streamtuner \
    --disable-sndio \
    --disable-aac  \
    --enable-ffaudio \
    %{?with_gtk:--enable-gtk} \
    %{!?with_gtk:--disable-gtk} \
    --disable-rpath
%make_build
%endif


%install
%if %{with meson}
%meson_install
%else
%make_install INSTALL="install -p"
%endif
%find_lang %{name}

mkdir -p %{buildroot}%{_datadir}/appdata
install -p -m0644 %{SOURCE100} %{buildroot}%{_datadir}/appdata
install -p -m0644 %{SOURCE101} %{buildroot}%{_datadir}/appdata
install -p -m0644 %{SOURCE102} %{buildroot}%{_datadir}/appdata
install -p -m0644 %{SOURCE103} %{buildroot}%{_datadir}/appdata


%files -f %{name}.lang
%license COPYING
%dir %{_libdir}/audacious
%dir %{_libdir}/audacious/Container/
%{_libdir}/audacious/Container/asx.so
%{_libdir}/audacious/Container/asx3.so
%{_libdir}/audacious/Container/audpl.so
%{_libdir}/audacious/Container/cue.so
%{_libdir}/audacious/Container/m3u.so
%{_libdir}/audacious/Container/pls.so
%{_libdir}/audacious/Container/xspf.so
%dir %{_libdir}/audacious/Effect/
%{_libdir}/audacious/Effect/background_music.so
%{_libdir}/audacious/Effect/bitcrusher.so
%{_libdir}/audacious/Effect/bs2b.so
%{_libdir}/audacious/Effect/compressor.so
%{_libdir}/audacious/Effect/crossfade.so
%{_libdir}/audacious/Effect/crystalizer.so
%{_libdir}/audacious/Effect/echo.so
%{_libdir}/audacious/Effect/mixer.so
%{_libdir}/audacious/Effect/resample.so
%{_libdir}/audacious/Effect/silence-removal.so
%{_libdir}/audacious/Effect/sox-resampler.so
%{_libdir}/audacious/Effect/speed-pitch.so
%{_libdir}/audacious/Effect/stereo.so
%{_libdir}/audacious/Effect/voice_removal.so
%dir %{_libdir}/audacious/General/
%{_libdir}/audacious/General/albumart-qt.so
%{_libdir}/audacious/General/ampache.so
%{_libdir}/audacious/General/playlist-manager-qt.so
%{_libdir}/audacious/General/qtui.so
%{_libdir}/audacious/General/search-tool-qt.so
%{_libdir}/audacious/General/skins-qt.so
%{_libdir}/audacious/General/song-info-qt.so
%{_libdir}/audacious/General/statusicon-qt.so
%{_libdir}/audacious/General/cd-menu-items.so
%{_libdir}/audacious/General/delete-files.so
%{_libdir}/audacious/General/lirc.so
%{_libdir}/audacious/General/lyrics-qt.so
%{_libdir}/audacious/General/mpris2.so
%{_libdir}/audacious/General/notify.so
%{_libdir}/audacious/General/scrobbler.so
%{_libdir}/audacious/General/song_change.so
%{_libdir}/audacious/General/streamtuner.so
%{_libdir}/audacious/General/qthotkey.so
%dir %{_libdir}/audacious/Input/
%{_libdir}/audacious/Input/cdaudio-ng.so
%{_libdir}/audacious/Input/flacng.so
%{_libdir}/audacious/Input/metronom.so
%{_libdir}/audacious/Input/modplug.so
%{_libdir}/audacious/Input/openmpt.so
%{_libdir}/audacious/Input/opus.so
%{_libdir}/audacious/Input/sndfile.so
%{_libdir}/audacious/Input/tonegen.so
%{_libdir}/audacious/Input/vorbis.so
%{_libdir}/audacious/Input/wavpack.so
%{_libdir}/audacious/Input/madplug.so
%dir %{_libdir}/audacious/Output/
%{_libdir}/audacious/Output/alsa.so
%{_libdir}/audacious/Output/filewriter.so
%{_libdir}/audacious/Output/oss4.so
%{_libdir}/audacious/Output/pipewire.so
%{_libdir}/audacious/Output/pulse_audio.so
%{_libdir}/audacious/Output/sdlout.so
%dir %{_libdir}/audacious/Visualization/
%{_libdir}/audacious/Visualization/blur_scope-qt.so
%{_libdir}/audacious/Visualization/gl-spectrum-qt.so
%{_libdir}/audacious/Visualization/qt-spectrum.so
%{_libdir}/audacious/Visualization/vumeter-qt.so
%dir %{_libdir}/audacious/Transport/
%{_libdir}/audacious/Transport/gio.so
%{_libdir}/audacious/Transport/mms.so
%{_libdir}/audacious/Transport/neon.so

%if %{with gtk}
%{_libdir}/audacious/General/albumart.so
%{_libdir}/audacious/General/aosd.so
%{_libdir}/audacious/General/gtkui.so
%{_libdir}/audacious/General/hotkey.so
%{_libdir}/audacious/General/lyrics-gtk.so
%{_libdir}/audacious/General/playlist-manager.so
%{_libdir}/audacious/General/search-tool.so
%{_libdir}/audacious/General/skins.so
%{_libdir}/audacious/General/statusicon.so
%{_libdir}/audacious/Effect/ladspa.so
%{_libdir}/audacious/Visualization/blur_scope.so
%{_libdir}/audacious/Visualization/cairo-spectrum.so
%{_libdir}/audacious/Visualization/gl-spectrum.so
%endif

%{_datadir}/audacious/

%files jack
%{_libdir}/audacious/Output/jack-ng.so
%{_datadir}/appdata/%{name}-jack.metainfo.xml

%files exotic
%{_libdir}/audacious/Input/adplug.so
%{_libdir}/audacious/Input/console.so
%{_libdir}/audacious/Input/psf2.so
%{_libdir}/audacious/Input/sid.so
%{_libdir}/audacious/Input/vtx.so
%{_libdir}/audacious/Input/xsf.so
%{_datadir}/appdata/%{name}-exotic.metainfo.xml

%files amidi
%{_libdir}/audacious/Input/amidi-plug.so
%{_datadir}/appdata/%{name}-amidi.metainfo.xml

%files ffaudio
%{_libdir}/audacious/Input/ffaudio.so
%{_datadir}/appdata/%{name}-ffaudio.metainfo.xml


%changelog
* Fri Jul 19 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.4-1
- initial build
